# Название:    Изменение размеров
# Сайт:             http://stroyka.in 
# Дата:             1.08.2008       
# Обновлён:    15.02.2016 
# Автор:            Sahi (г.Рязань)
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#   
module Sahi
                  
module Mashtab
                  
  def self.group_point(group)
      mass = []
      group.entities.to_a.each{|line|
      mass << line.start.position if line.class == Sketchup::Edge
      mass << line.end.position if line.class == Sketchup::Edge
      mass << group_point(line) if(line.kind_of?(Sketchup::Group))
      mass << component_point(line) if(line.kind_of?(Sketchup::ComponentInstance))
      }
     return mass
    end
  
  def self.component_point(comp)
      mass = []
      comp.definition.entities.to_a.each{|line|
      mass << line.start.position if line.class == Sketchup::Edge
      mass << line.end.position if line.class == Sketchup::Edge
      mass << group_point(line) if(line.kind_of?(Sketchup::Group))
      mass << component_point(line) if(line.kind_of?(Sketchup::ComponentInstance))
      }
     return mass
   end
   
 def self.mashtabirovanie()  
  model = Sketchup.active_model
  ss=model.selection 
         
    if(ss.empty?) 
        UI.messagebox("NO Selection ")
      return nil
    end
    model.start_operation("Resize", false,false,false) rescue model.start_operation("Resize", true) rescue model.start_operation("Resize")
        entities = model.active_entities
        sents=[]
    if((ss[0].is_a?(Sketchup::Group) or ss[0].is_a?(Sketchup::ComponentInstance)) and ss.nitems <2)
         mass = []
          ss[0].make_unique
          sel = ss[0].entities if ss[0].is_a?(Sketchup::Group)
          sel = ss[0].definition.entities if ss[0].is_a?(Sketchup::ComponentInstance)
          sel.to_a.each{|line|
             mass << line.start.position if line.class == Sketchup::Edge
             mass << line.end.position if line.class == Sketchup::Edge
             mass << group_point(line) if(line.kind_of?(Sketchup::Group))
             mass << component_point(line) if(line.kind_of?(Sketchup::ComponentInstance))
           }
        xgroup = entities.add_group ss[0] if ss[0].is_a?(Sketchup::Group)
        xgroup = entities.add_group ss[0].definition.instances if ss[0].is_a?(Sketchup::ComponentInstance)
        vgroup = sel.add_group
        boundingbox = vgroup.bounds
        copy_group = boundingbox.add(mass.flatten)
        sel.to_a.each{|e|sents.push(e)}
        else
          ss.to_a.each{|e|sents.push(e)}
          xgroup=entities.add_group(sents)
          copy_group = xgroup.bounds
        end
        
        center = copy_group.corner(0).clone
        dept = @dlina =copy_group.depth
        widt =@shirina =copy_group.width
        heigh = @visota =copy_group.height
        kopiya = "No" if not kopiya
        nazv = "From the Center" if not nazv
        scal = 0.to_l if not scal

        style = "From the Center|On blue|On Red|On Green"
        k_style = "Yes|No"
        prompts = ["Choose axis","Enter distance: ", "On blue","On Red","On Green", "Copy"]
        values = [nazv,scal,dept,widt,heigh,kopiya]
        enums =[style,'','','','',k_style ]
        results = inputbox prompts, values, enums, "Resize"
        Sketchup.active_model.abort_operation and return if not results
         nazv,scal,dept,widt,heigh,kopiya = results
         
      begin  
        der_z = der_x = der_y = 1
        der_y = (dept/@dlina).to_f  if(@dlina != dept)
        der_x = (widt/@shirina).to_f  if(@shirina != widt)
        der_z = (heigh/@visota).to_f if(@visota != heigh)
        center = copy_group.center.clone if(nazv == "From the Center")
    if(scal !=0)
        if(nazv == "From the Center")
          der_y = ((dept + scal)/@dlina).to_f if(@dlina != 0.0)
          der_x = ((widt + scal)/@shirina).to_f if(@shirina != 0.0)
          der_z = ((heigh + scal)/@visota).to_f if(@visota != 0.0)
         end
       der_z = der_x = der_y = ((dept + scal)/@dlina).to_f if(nazv == "On blue")
       der_z = der_x = der_y = ((widt + scal)/@shirina).to_f if(nazv == "On Red")
       der_z = der_x = der_y = ((heigh + scal)/@visota).to_f if(nazv == "On Green")
     end
        unless kopiya == "No"
        comp = xgroup.copy
        comp.make_unique
        comp.entities.each{|item| item.make_unique}
        comp.explode
       end
        xgroup.explode
        trans = Geom::Transformation.scaling(center, der_x, der_z, der_y)
        entities.transform_entities(trans, sents)
        
        Sketchup.active_model.selection.clear
        Sketchup.active_model.commit_operation
        Sketchup.active_model.select_tool(nil)
       rescue => err
       puts err.to_s
       Sketchup.active_model.abort_operation
      end
    end
#--------------------------------------------------------------------------
   
if( not file_loaded?(__FILE__))
   sahi_toolbar_tools = UI::Toolbar.new("Resize")
	 cmd = UI::Command.new("Resize"){Sahi::Mashtab.mashtabirovanie()}
 	 cmd.small_icon = "./images/mashtab.png"
 	 cmd.large_icon = "./images/mashtab.png"
	 cmd.tooltip = "Resize"
	 sahi_toolbar_tools.add_item cmd
   sahi_toolbar_tools.show

  #add_separator_to_menu("Plugins")  #добавляем в меню "Plugins"
   # UI.menu("Plugins").add_item("Resizer "){Sahi::Mashtab.mashtabirovanie()}
end
# - - - - - - - - -     # - - - - - - - - -     # - - - - - - - - -
end # Mashtab
# - - - - - - - - -     # - - - - - - - - -     # - - - - - - - - -
end # Sahi
